﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media;
using System.Windows.Shapes;

namespace CatanGame.View
{
    class HexagonFactory
    {
        private static double sqrt3 = Math.Sqrt(3);
        private static double sqrt3div2 = sqrt3 / 2;
        private static double[] idToCos = new double[]{ 
            sqrt3div2, sqrt3div2, 0, -sqrt3div2, -sqrt3div2, 0
        };
        private static double[] idToSin = new double[] {
            -0.5, 0.5, 1, 0.5, -0.5, -1, 
        };

        public static Polygon MakeHexagon(Point center, double size)
        {
            PointCollection hexagonCorners = new PointCollection();

            for (int i = 0; i < 6; i++)
                hexagonCorners.Add(HexCorner(center, size, i));

            Polygon newHexagon = new Polygon();
            newHexagon.Points = hexagonCorners;
            return newHexagon;
        }

        public static Point HexCorner(Point center, double size, int i)
        {
            return new Point(center.X + size * idToCos[i],
                             center.Y + size * idToSin[i]);
        }
    }
}
